"
 COPYRIGHT (c) 2009 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic3' }"

VersionInfo subclass:#CVSVersionInfo
	instanceVariableNames:'repositoryPathName timeZone state'
	classVariableNames:''
	poolDictionaries:''
	category:'System-SourceCodeManagement'
!

!CVSVersionInfo class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2009 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Class used to return a Dictionary when asked for versionInfo.
    This has been replaced by instances of VersionInfo and subclasses.

    Notice, that CVSVersionInfo adds some CVS specific data.

    [author:]
        cg (cg@AQUA-DUO)
"
! !

!CVSVersionInfo class methodsFor:'instance creation'!

fromRCSString:aString
    "{ Pragma: +optSpace }"

    "I know how to parse RCS/CVS version id strings.
     Return an instance filled with revision info which is
     extracted from aString. This must be in RCS/CVS format."

    |words firstWord nextWord info nm s|

    s := aString readStream.
    s skipSeparators.
    firstWord := s upToSeparator.

    info := self new.

    "/
    "/ supported formats:
    "/
    "/ $-Header:   pathName rev date time user state $
    "/ $-Revision: rev $
    "/ $-Id:       fileName rev date time user state $
    "/
    (firstWord = '$Header:') ifTrue:[
        s skipSeparators.
        nm := s throughAll:',v '.
        nm := nm withoutSeparators.
        info repositoryPathName:nm.
        info fileName:(nm asFilename baseName copyWithoutLast:2).
        words := s upToEnd asCollectionOfWords readStream.

        words atEnd ifFalse:[
            nextWord := words next.
            nextWord ~= '$' ifTrue:[
                info revision:nextWord.
                nextWord := words next.
                nextWord ~= '$' ifTrue:[
                    info date:nextWord.
                    info time:words next.
                    nextWord := words next.
                    (nextWord startsWithAnyOf:'+-') ifTrue:[
                        info timezone:nextWord.
                        nextWord := words next.
                    ].
                    info user:nextWord.
                    info state:words next.
                ]
            ].
        ].
        ^ info
    ].

    (firstWord = '$Revision:') ifTrue:[
        info revision:(s upToEnd asCollectionOfWords first).
        ^ info
    ].

    (firstWord = '$Id:') ifTrue:[
        self halt:'no longer supported'.
        words := s upToEnd asCollectionOfWords readStream.
        info fileName:(words next).
        info revision:(words next).
        info date:(words next).
        info time:(words next).
        info user:(words next).
        info state:(words next).
        ^ info
    ].

    ^ nil

    "
     CVSVersionInfo fromRCSString:('$' , 'Revision: 1.122 $')
     CVSVersionInfo fromRCSString:(SourceCodeManager version)
    "

    "Modified: / 22-10-2008 / 20:17:00 / cg"
! !

!CVSVersionInfo methodsFor:'accessing'!

repositoryPathName
    ^ repositoryPathName
!

repositoryPathName:something
    repositoryPathName := something.
!

state
    ^ state
!

state:something
    state := something.
!

timeZone
    ^ timeZone
!

timeZone:something
    timeZone := something.
!

timezone
    ^ timeZone

    "Created: / 22-10-2008 / 20:50:39 / cg"
!

timezone:something
    timeZone := something.

    "Created: / 22-10-2008 / 20:50:32 / cg"
! !

!CVSVersionInfo class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/CVSVersionInfo.st,v 1.3 2009-09-29 19:32:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libbasic3/CVSVersionInfo.st,v 1.3 2009-09-29 19:32:39 cg Exp $'
! !
